<?php

namespace backend\controllers;

use Yii;
use common\models\AccountState;
use backend\models\AccountStateSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use common\models\Account;
use common\models\User;
use common\components\DailyListing;

/**
 * AccountStateController implements the CRUD actions for AccountState model.
 */
class AccountStateController extends \backend\controllers\BackendController
{

	public function behaviors()
	{
		return [
				'access' => [
						'class' => \yii\filters\AccessControl::className(),
						'rules' => [
								// allow authenticated users
								[
										'actions' => ['create','index','view','update','delete'],
										'allow' => true,
										'roles' => ['admin','employee','reception'],
								],
								// everything else is denied
						],
				],
		];
	}
	
    /**
     * Lists all AccountState models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new AccountStateSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        $accounts = Account::read();
        $users = User::read();
        
        
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        		'accounts' => $accounts,
        		'users' => $users,
        ]);
    }

    /**
     * Displays a single AccountState model.
     * @param integer $id
     * @return mixed
     */
/*
	 * Displays a single AccountState model.
	 * @param integer $id
	 * $var common\models\AccountState $accountState
	 * @return mixed
	 */
	public function actionView($id) {
		$accountState = $this->findModel ( $id );
		$output = Yii::$app->getRequest ()->getQueryParam ( 'output' );
		$details = null;
		if ($accountState->isTypeClose ()) {
			
			$prev;
			if ($accountState->type == AccountState::TYPE_CLOSE) {
				if (isset ( $accountState->prev_state )) {
					$prev = AccountState::findOne ( $accountState->prev_state );
				}
				if (isset ( $prev )) {
					$accountState->start_date = $prev->created_at;
				}
			}
			$details = new DailyListing();
			$details->loadAccountState ( $accountState );
			
			$details->readTotalEasy ();
			$details->readTotalDetailed ();
			$details->readTotalMedium ();
		}
		
		if ($output == 'pdf') {
			$user = User::findOne(\Yii::$app->user->id);
			$mpdf=new \mPDF('utf-8', 'A4-L');
			$mpdf->useSubstitutions=false;
			$mpdf->simpleTables = true;
			$mpdf->SetHeader( \Yii::$app->params[ "company_name" ] . " - Létrehozva: "  .$user->username . ", ".\Yii::$app->formatter->asDatetime(time()) );
			$mpdf->setFooter('{PAGENO} / {nb}');
			
			$stylesheet = file_get_contents( \Yii::getAlias('@vendor'.'/bower/bootstrap/dist/css/bootstrap.css')); // external css
			$mpdf->WriteHTML($stylesheet,1);
			
			
			$mpdf->WriteHTML($this->renderPartial("@common/views/account-state/account_state_pdf", [
					'model' => $accountState,
					'details' => $details 
			]));
			$type = $accountState->isTypeOpen() ? "kassza_nyitas" : "kassza_zaras";
			$dt= "_letrehozva_".date("Ymd_His"). "_" . $user->username; 
			$fn= $type .$dt.".pdf";
			$mpdf->Output($fn, 'D');
			
		} else {
			
			return $this->render ( 'view', [ 
					'model' => $accountState,
					'details' => $details 
			] );
		}
	}

    /**
     * Creates a new AccountState model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new AccountState();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_account_state]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing AccountState model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id_account_state]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    
    /**
     * Deletes an existing AccountState model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     *
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id) {
    	$model = $this->findModel ( $id );
    	
    	$delete = true;
    	if ( $model->isTypeOpen() ){
    		$closeStates = AccountState::find()->andWhere( ['prev_state' => $model->id_account_state] )->all();
    		
    		if ( count($closeStates) > 0){
				$delete = false;
    			\Yii::$app->session->setFlash('error', ['Nem lehet törölni a nyitást, mert van kapcsolódó zárás!']);
    			throw new \Exception('Nem lehet törölni a nyitást, mert van kapcsolódó zárás!');
    		} 
    		
    	}
    	
    	if ( $delete == true ){
    		$model->delete();
    		\Yii::$app->session->setFlash ( 'success', 'Kassza művelet törölve' );
    	} 
    	
    	return $this->redirect ( ["index"] );
    }
    
    /**
     * Deletes an existing AccountState model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }
     */

    /**
     * Finds the AccountState model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return AccountState the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = AccountState::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}
